const f32 MAX_SPEED = 8.0f;

void onInit(CBlob@ this)
{
	ShapeConsts@ consts = this.getShape().getConsts();
	consts.bullet = true;
	consts.net_threshold_multiplier = 0.5f;
	this.getShape().SetGravityScale(0.4f);
	this.getSprite().SetZ(100.0f);
	this.SetMapEdgeFlags(u8(CBlob::map_collide_none));
}


void onCollision(CBlob@ this, CBlob@ blob, bool solid)
{
	const f32 vellen = this.getShape().vellen;

	if (solid)
	{
		const f32 vellen = this.getShape().vellen;
		const f32 fullTime = getTicksASecond() * 3.0f;
		this.getSprite().PlayRandomSound("BallDrop", 1.0f, 1.0f);
	}

	if (blob !is null)
	{
		if (blob.hasTag("player") && !blob.hasTag("bouncer"))
		{
			blob.server_AttachTo(this, 0);
		}
	}
}

void onTick(CBlob@ this)
{
	// limit speed
	const f32 vellen = this.getShape().vellen;
	if (vellen > MAX_SPEED)
	{
		Vec2f vel = this.getVelocity();
		vel.Normalize();
		this.setVelocity(vel * MAX_SPEED);
	}
}
