#include "GameColours.as"
#include "Sparks.as"
#include "ExplosionParticles.as"
#include "Explosion.as"

const f32 MAX_VEL = 9.0f;
const f32 RADIUS = 40.0f;
const f32 DAMAGE = 3.0f;

void onInit( CBlob@ this )
{
	this.getSprite().SetZ(100.0f);
	this.Tag("explosive");
	this.SetMapEdgeFlags( u8(CBlob::map_collide_none) );
}

void onDie( CBlob@ this )
{
	Vec2f pos = this.getPosition();

	Explode( this, RADIUS, DAMAGE );

	if (getNet().isClient())
	{
		Particles::Sparks( pos, 17, 27.0f, SColor(Colours::RED) );
		Particles::Sparks( pos, 10, 27.0f, SColor(Colours::YELLOW) );

		Particles::Explosion(pos, 4, this.getVelocity() );

		ShakeScreen2( 30.0f, 15, pos );

		Sound::isTooFar(pos) ? Sound::Play2D("DistantExplosion", 0.5f, pos.x > getCamera().getPosition().x ? 1.0f : -1.0f) : this.getSprite().PlaySound( "GrenadeExplosion" );
	}
}

void onCollision( CBlob@ this, CBlob@ blob, bool solid )
{
	if (solid && blob is null)
	{
		const f32 vellen = this.getShape().vellen;
		const f32 fullTime = getTicksASecond() * 3.0f;
		this.getSprite().PlayRandomSound( "GrenadeDrop", vellen/MAX_VEL, 0.5f + 0.25f * (fullTime - this.getTicksToDie())/fullTime );
	}
}


bool doesCollideWithBlob( CBlob@ this, CBlob@ blob )
{
	return blob.hasTag("collide with nades");
}
